--- src/emacs.c.orig	2014-03-21 14:34:40.000000000 +0900
+++ src/emacs.c	2014-12-24 00:02:51.000000000 +0900
@@ -23,6 +23,8 @@
 
 #include <errno.h>
 #include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
 
 #include <sys/types.h>
 #include <sys/file.h>
@@ -766,6 +768,24 @@
 #ifdef DARWIN_OS
   if (!initialized)
     unexec_init_emacs_zone ();
+
+  /* Imaxima won't work properly if PATH does not contain the
+     MacPorts directory. The following code is a workaround to
+     avoid this problem. */
+  {
+    char *oldpath = getenv("PATH");
+    if (!oldpath) {oldpath = "";}
+    size_t oldpathsize = strlen(oldpath) + 1;
+    if (!strstr(oldpath, "__PREFIX__/bin")) {
+      char *newpath;
+      size_t newpathsize = oldpathsize + strlen("__PREFIX__/bin:");
+      if ((newpath = (char *)malloc(newpathsize)) != NULL) {
+        strlcpy(newpath, "__PREFIX__/bin:", newpathsize);
+        strlcat(newpath, oldpath, newpathsize);
+        setenv("PATH", newpath, 1);
+      }
+    }
+  }
 #endif
 
   atexit (close_output_streams);
